VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CD8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Drives"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD CD class allows the playing of CD tracks within the Sound Engine.
Attribute VB_HelpID=2331
Attribute VB_Description="CD class allows the playing of CD tracks within the Sound Engine."
Option Explicit

Private mvarTrayOpen As Boolean
Private AliasName As String 'Holds the alias name for the opened file.
Private mvarDrives As Drives8

Public Enum eCDStatus
'##EN Current status of the CD player.
    Playing = 0
    '##EM Playing CD is currently playing a track.
    Stopped = 1
    '##EM Stopped CD is currently stopped.
    Other = 2
    '##EM Other Something other then playing, stopped, or indefinable.
End Enum

Public Enum eCDCapabilities
'##EN Capability flags.
    eCanEject = 1
    '##EM eCanEject Can eject.
    eCanPlay = 2
    '##EM eCanPlay Can play.
    eCanRecord = 3
    '##EM eCanRecord Can record.
    eCanSave = 4
    '##EM eCanSave Can save.
    eCompoundDevice = 5
    '##EM eCompoundDevice Is a compound device.
    eHasAudio = 6
    '##EM eHasAudio Has audio
    eHasVideo = 7
    '##EM eHasVideo Has video
    eUsesFiles = 8
    '##EM eUsesFiles Uses files.
End Enum

'Private stuff.==================
'GetDriveType return values
Const DRIVE_REMOVABLE = 2
Const DRIVE_FIXED = 3
Const DRIVE_REMOTE = 4
Const DRIVE_CDROM = 5
Const DRIVE_RAMDISK = 6
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

Public Function Capabilities(ByVal CapabilityType As eCDCapabilities) As Boolean
Attribute Capabilities.VB_HelpID = 2454
Attribute Capabilities.VB_Description = "Returns if the CD has a certain capability."
'##BD Returns if the CD has a certain capability.

'##PD CapabilityType Type of capability to check for.
'##RD True if the CD player has the capability or False if not.
    Dim s As String * 35, X As Long, sReturn As String * 128
    
    If CapabilityType = eCanEject Then
        X = mciSendString("capability " & AliasName & " can eject", s, Len(s), 0)
    ElseIf CapabilityType = eCanPlay Then
        X = mciSendString("capability " & AliasName & " can play", s, Len(s), 0)
    ElseIf CapabilityType = eCanRecord Then
        X = mciSendString("capability " & AliasName & " can record", s, Len(s), 0)
    ElseIf CapabilityType = eCanSave Then
        X = mciSendString("capability " & AliasName & " can save", s, Len(s), 0)
    ElseIf CapabilityType = eCompoundDevice Then
        X = mciSendString("capability " & AliasName & " compound device", s, Len(s), 0)
    ElseIf CapabilityType = eHasAudio Then
        X = mciSendString("capability " & AliasName & " has audio", s, Len(s), 0)
    ElseIf CapabilityType = eHasVideo Then
        X = mciSendString("capability " & AliasName & " has video", s, Len(s), 0)
    ElseIf CapabilityType = eUsesFiles Then
        X = mciSendString("capability " & AliasName & " uses files", s, Len(s), 0)
    End If
    If X <> 0 Then 'Error occured
        Capabilities = False
    Else
        If InStr(1, s, "true", vbTextCompare) > 0 Then
            Capabilities = True
        ElseIf InStr(1, s, "false", vbTextCompare) > 0 Then
            Capabilities = False
        Else
            Capabilities = False
        End If
    End If
End Function
Public Property Get Drives() As Drives8
Attribute Drives.VB_HelpID = 2455
Attribute Drives.VB_Description = "Returns a collection CDROM drives on the current machine. Use these drives to specify which drive you want to play CD music from."
'##BD Returns a collection CDROM drives on the current machine. Use these drives to specify which drive you want to play CD music from.
    Set Drives = mvarDrives
End Property

Public Property Get CDInTray() As Boolean
Attribute CDInTray.VB_HelpID = 2334
Attribute CDInTray.VB_Description = "Returns true if a CD is inside the CD player."
'##BD Returns true if a CD is inside the CD player.
    Dim s As String * 30, X As Long, sRet As String * 128

    X = mciSendString("status " & AliasName & " media present", s, Len(s), 0)
    If X <> 0 Then  'not success
        Call mciGetErrorString(X, sRet, Len(sRet))
        CDInTray = False
    Else
        CDInTray = True
    End If
End Property

Public Sub InitializeCDROM(Optional Drive As Drive8)
Attribute InitializeCDROM.VB_HelpID = 2456
Attribute InitializeCDROM.VB_Description = "Initialize either the default or specified CDROM."
'##BD Initialize either the default or specified CDROM.

'##PD Drive Drive object that contains the drive letter mapping used to initialize the proper CDROM for CD playing.
    Dim X As Long, sReturn As String * 128
    On Error GoTo Handler
    
    Call CloseCD 'Close the tray door.
    
    AliasName = "CD" & GetRandomNumber(1000, 1) 'Make a alias name
    If IsMissing(Drive) Then 'If the user didn't specifiy which drive to use we use the default one.
        X = mciSendString("open cdaudio alias " & AliasName & " wait shareable", 0, 0, 0) 'Make CD ready.
    Else
        X = mciSendString("open " & Drive.DriveLetter & " type cdaudio alias " & AliasName & " wait shareable", 0&, 0, 0) 'Code from GabitaSoftCD AudioCD class.
    End If
    'Check for error
    If X <> 0 Then Call mciGetErrorString(X, sReturn, 128)             'Get the error
    If X = 0 Then Call SEngine.FireEvents(13) 'Fire cdrominitialize event.
    
    'Set the format.
    Call SetFormatToMinutesSeconds 'Set the format.
    Exit Sub
    
Handler:
    Call SEngine.FireErrorEvent(X, sReturn, "CD | InitializeCDROM Method")
End Sub

Public Property Get Status() As eCDStatus
Attribute Status.VB_HelpID = 2335
Attribute Status.VB_Description = "Returns the current status of the CD player."
'##BD Returns the current status of the CD player.
    Dim s As String * 30, X As Long, sRet As String * 128

    X = mciSendString("status " & AliasName & " mode", s, Len(s), 0)
    If X <> 0 Then  'not success
        Call mciGetErrorString(X, sRet, Len(sRet))
        Status = Other
    Else
        If InStr(1, s, "playing") Then
            Status = Playing
        ElseIf InStr(1, s, "stopped") Then
            Status = Stopped
        Else
            Status = Other
        End If
    End If
End Property
Public Sub OpenCD()
Attribute OpenCD.VB_HelpID = 2336
Attribute OpenCD.VB_Description = "Opens the CD player's tray door. (A.K.A. Eject)"
'##BD Opens the CD player's tray door. (A.K.A. Eject)
    Call mciSendString("set cd door open", 0, 0, 0)
    mvarTrayOpen = True
    Call SEngine.FireEvents(7)
End Sub



Public Sub CloseCD()
Attribute CloseCD.VB_HelpID = 2337
Attribute CloseCD.VB_Description = "Closes the CD player's tray door."
'##BD Closes the CD player's tray door.
    Call mciSendString("set cd door closed", 0, 0, 0)
    mvarTrayOpen = False
    Call SEngine.FireEvents(8)
End Sub




Public Sub Play()
Attribute Play.VB_HelpID = 2338
Attribute Play.VB_Description = "Plays the CD at the selected track. If no track has been set using the SetTrack method prior to this call the CD will play from the beginning."
'##BD Plays the CD at the selected track. If no track has been set using the SetTrack method prior to this call the CD will play from the beginning.
    Dim sReturn As String * 128, X As Long
    On Error GoTo Handler

    X = mciSendString("play " & AliasName, 0, 0, 0) 'Send the command
    If X <> 0 Then 'If error report the error
        Call mciGetErrorString(X, sReturn, 128)      'Get the error
        GoTo Handler
    Else
        Call SEngine.FireEvents(10)
    End If
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(X, sReturn, "CD | PlayTrack Method")
End Sub

Public Sub Pause()
Attribute Pause.VB_HelpID = 2339
Attribute Pause.VB_Description = "Pauses the playing of the CD player."
'##BD Pauses the playing of the CD player.
    Call mciSendString("pause " & AliasName, 0, 0, 0)
    Call SEngine.FireEvents(12)
End Sub

Public Sub SetTrack(ByVal Track As Long)
Attribute SetTrack.VB_HelpID = 2340
Attribute SetTrack.VB_Description = "Sets the track you wish to play."
'##BD Sets the track you wish to play.

'##PD Track Track number you wish to set the CD player too.
    Call mciSendString("seek " & AliasName & " to " & Str(Track), 0, 0, 0)
End Sub
Public Sub FastForward(ByVal Spd As Integer)
Attribute FastForward.VB_HelpID = 2341
Attribute FastForward.VB_Description = "Seeks the CD player to a further time period."
'##BD Seeks the CD player to a further time period.

'##PD Spd Speed at which you wish to seek the CD player.
    Dim s As String * 40

    Call SetFormatToMilliseconds 'Set time format to milliseconds.

    Call mciSendString("status " & AliasName & " position wait", s, Len(s), 0) 'set position.
    If Status <> "playing" Then
        Call mciSendString("play " & AliasName & " from " & CStr(CLng(s) + Spd), 0, 0, 0)
    Else
        Call mciSendString("seek " & AliasName & " to " & CStr(CLng(s) + Spd), 0, 0, 0) 'It's playing so we just seek it.
    End If

    Call SetFormatToMinutesSeconds 'Set format back to minutes and seconds.
End Sub

Public Sub Rewind(ByVal Spd As Integer)
Attribute Rewind.VB_HelpID = 2342
Attribute Rewind.VB_Description = "Seeks the CD player back to a different time period."
'##BD Seeks the CD player back to a different time period.

'##PD Spd Speed at which you wish to seek the CD player back.
    Dim s As String * 40

    SetFormatToMilliseconds 'Set time format to milliseconds.

    Call mciSendString("status " & AliasName & " position wait", s, Len(s), 0) 'set position.
    If Status <> "playing" Then
        Call mciSendString("play " & AliasName & " from " & CStr(CLng(s) - Spd), 0, 0, 0) 'start play at that position.
    Else
        Call mciSendString("seek " & AliasName & " to " & CStr(CLng(s) - Spd), 0, 0, 0) 'Seek to the position.
    End If

    SetFormatToMinutesSeconds 'Set format back to minutes and seconds.
End Sub

Public Property Get TrackCount() As Long
Attribute TrackCount.VB_HelpID = 2343
Attribute TrackCount.VB_Description = "Total number of tracks on the CD."
'##BD Total number of tracks on the CD.
    Dim s As String * 30
    On Error GoTo Handler
    
    Call mciSendString("status " & AliasName & " number of tracks wait", s, Len(s), 0)
    TrackCount = CLng(s)
    Exit Property
    
Handler:
    TrackCount = 0
End Property

Public Property Get CurrentTrack() As Long
Attribute CurrentTrack.VB_HelpID = 2344
Attribute CurrentTrack.VB_Description = "Returns the current track that is playing."
'##BD Returns the current track that is playing.
    Dim s As String * 30
    On Error GoTo Handler
    
    Call mciSendString("status " & AliasName & " position", s, Len(s), 0) 'Grab position information.
    CurrentTrack = CInt(Mid$(s, 1, 2))
    Exit Property
    
Handler:
    CurrentTrack = 0
End Property



Public Property Get CurrentTime() As String
Attribute CurrentTime.VB_HelpID = 2345
Attribute CurrentTime.VB_Description = "Returns the current time at which the CD is playing at. For example: 1:21."
'##BD Returns the current time at which the CD is playing at. <b>For example: 1:21.</b>
    Dim s As String * 30
    On Error GoTo Handler

    Call mciSendString("status " & AliasName & " position", s, Len(s), 0) 'Grab position information.
    CurrentTime = format$(Mid$(s, 4, 2) & Mid$(s, 7, 2), "##:##")
    Exit Property

Handler:
    CurrentTime = "00:00"
End Property
Public Function GetTrackLength(ByVal TrackNum As Long) As String
Attribute GetTrackLength.VB_HelpID = 2346
Attribute GetTrackLength.VB_Description = "Retrieves the passed in tracks total length."
'##BD Retrieves the passed in tracks total length.

'##PD TrackNum Track you wish to find the length for.
    Dim s As String * 10

    Call mciSendString("status " & AliasName & " length track " & TrackNum, s, Len(s), 0)
    GetTrackLength = s
End Function

Public Property Get CDLength() As String
Attribute CDLength.VB_HelpID = 2347
Attribute CDLength.VB_Description = "Returns the length of all the tracks added together."
'##BD Returns the length of all the tracks added together.
    Dim s As String * 30

    Call mciSendString("status " & AliasName & " length wait", s, Len(s), 0)
    CDLength = Replace(s, Chr(0), "")
End Property

Public Property Get CDID() As String
Attribute CDID.VB_HelpID = 2457
Attribute CDID.VB_Description = "Returns the unique identifier for the audio CD currently loaded in the player."
'##BD Returns the unique identifier for the audio CD currently loaded in the player.
    Dim s As String * 35, X As Long, sReturn As String * 128

    X = mciSendString("info " & AliasName & " identity", s, Len(s), 0)
    CDID = Replace(s, Chr(0), "")
End Property

Public Property Get CDUPC() As String
Attribute CDUPC.VB_HelpID = 2458
Attribute CDUPC.VB_Description = "Returns the unique identifier for the audio CD currently loaded in the player."
'##BD Returns the unique identifier for the audio CD currently loaded in the player.
    Dim s As String * 35, X As Long, sReturn As String * 128

    X = mciSendString("info " & AliasName & " upc", s, Len(s), 0)
    If X = 350 Then
        CDUPC = "No Universal Product Code."
    Else
        CDUPC = Replace(s, Chr(0), "")
    End If
End Property
Private Sub SetFormatToMinutesSeconds()
Attribute SetFormatToMinutesSeconds.VB_HelpID = 2348
    Call mciSendString("set " & AliasName & " time format tmsf wait", 0, 0, 0)
End Sub
Private Sub SetFormatToMilliseconds()
Attribute SetFormatToMilliseconds.VB_HelpID = 2349
    Call mciSendString("set " & AliasName & " time format milliseconds", 0, 0, 0)
End Sub
Public Sub StopPlay()
Attribute StopPlay.VB_HelpID = 2350
Attribute StopPlay.VB_Description = "Stops the CD from playing."
'##BD Stops the CD from playing.
    Dim sReturn As String * 128, X As Long
    On Error GoTo Handler

    X = mciSendString("stop " & AliasName, 0, 0, 0) 'send the command.
    Call SetTrack(1) 'Set CD to the beginning.
    If X <> 0 Then 'If error notify the user.
        Call mciGetErrorString(X, sReturn, 128)      'Get the error
        GoTo Handler
    Else
        Call SEngine.FireEvents(11)
    End If
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(X, sReturn, "CD | StopPlay Method")
End Sub


Public Property Get TrayOpen() As Boolean
Attribute TrayOpen.VB_HelpID = 2351
Attribute TrayOpen.VB_Description = "Returns true if the CD player's tray door is open."
'##BD Returns true if the CD player's tray door is open.
    TrayOpen = mvarTrayOpen
End Property

Private Sub Class_Initialize()
    Dim sReturn As String * 128, X As Long
    Dim i As Long, a As String, k As Long, Drive As Drive8
    On Error Resume Next
    
    'Load all the CDROM type drives on the system into a collection.
    Set mvarDrives = New Drives8 'Create new collection.
    For i = 0 To 25 'Grab all of the CDRoms on the system.
        a = Chr$(i + 65) & ":\"
        k = GetDriveType(a)
        If k = DRIVE_CDROM Then Call mvarDrives.Add(mvarDrives.Count + 1, a, a) 'Add to list of drives.
    Next
End Sub

Private Sub Class_Terminate()
    'Stop using it.
    Call mciSendString("stop cd", 0&, 0, 0) 'Code from GabitaSoftCD AudioCD class.
    Call mciSendString("close cd", 0&, 0, 0) 'Code from GabitaSoftCD AudioCD class.
    Call mciSendString("close all", 0&, 0, 0)
End Sub


