VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Listener8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Listener class allows the manipulation of the DirectSound3DListener object.
Attribute VB_HelpID=2486
Attribute VB_Description="Listener class allows the manipulation of the DirectSound3DListener object."
Option Explicit

Public Property Let DistanceFactor(ByVal DistanceFactor As Single)
Attribute DistanceFactor.VB_HelpID = 2487
Attribute DistanceFactor.VB_Description = "Returns/Sets the distance factor.  "
    Call DSListener3D.SetDistanceFactor(DistanceFactor, DS3D_IMMEDIATE)
End Property

Public Property Get DistanceFactor() As Single

'##BD Returns/Sets the distance factor.

'##PD DopplerFactor New distance factor value.
    DistanceFactor = DSListener3D.GetDistanceFactor
End Property

Public Property Let DopplerFactor(ByVal DopplerFactor As Single)
Attribute DopplerFactor.VB_HelpID = 2488
Attribute DopplerFactor.VB_Description = "Returns/Sets the doppler factor.  "
    Call DSListener3D.SetDopplerFactor(DopplerFactor, DS3D_IMMEDIATE)
End Property

Public Property Get DopplerFactor() As Single

'##BD Returns/Sets the doppler factor.

'##PD DopplerFactor New Doppler factor value.
    DopplerFactor = DSListener3D.GetDopplerFactor
End Property

Public Property Let RolloffFactor(ByVal RolloffFactory As Single)
Attribute RolloffFactor.VB_HelpID = 2489
Attribute RolloffFactor.VB_Description = "Returns/Sets the rolloff factor.Retrieves the current rolloff factor. Returns/Sets the rolloff factor."
'##BD Returns/Sets the rolloff factor.

'##PD RolloffFactory New rolloff factor value.
    Call DSListener3D.SetRolloffFactor(RolloffFactory, DS3D_IMMEDIATE)
End Property
Public Property Get RolloffFactor() As Single
'##BD Retrieves the current rolloff factor.
    RolloffFactor = DSListener3D.GetRolloffFactor
End Property
Public Sub SetVelocity(x As Single, y As Single, z As Single)
Attribute SetVelocity.VB_HelpID = 2490
Attribute SetVelocity.VB_Description = "Sets the listener's velocity."

'##BD Sets the listener's velocity.

'##PD x Value that represent the coordinates of the listener's new velocity vector. <i><b>Note:</b> that DirectSound may adjust these values to prevent floating-point overflow.</i>
'##PD y Value that represent the coordinates of the listener's new velocity vector. <i><b>Note:</b> that DirectSound may adjust these values to prevent floating-point overflow.</i>
'##PD z Value that represent the coordinates of the listener's new velocity vector. <i><b>Note:</b> that DirectSound may adjust these values to prevent floating-point overflow.</i>
    Call DSListener3D.SetVelocity(x, y, z, DS3D_IMMEDIATE)
End Sub

Public Property Get Velocity() As D3DVECTOR
Attribute Velocity.VB_HelpID = 2491
Attribute Velocity.VB_Description = "Retrieves the listener's current velocity."

'##BD Retrieves the listener's current velocity.
    Velocity = DSListener3D.GetVelocity
End Property
Public Property Get SoundBuffer3DListener() As DirectSound3DListener8
Attribute SoundBuffer3DListener.VB_HelpID = 2492
Attribute SoundBuffer3DListener.VB_Description = "Returns/Sets the DirectSound3DListener object. Use this object for custom operations.  "

'##BD Returns/Sets the DirectSound3DListener object. Use this object for custom operations.
    Set SoundBuffer3DListener = DSListener3D
End Property

Public Property Set SoundBuffer3DListener(ByVal vData As DirectSound3DListener8)
    Set DSListener3D = vData
End Property
Public Sub SetPosition(ByVal x As Single, ByVal y As Single, ByVal z As Single)
Attribute SetPosition.VB_HelpID = 2493
Attribute SetPosition.VB_Description = "Sets the listener's current position, in distance units."

'##BD Sets the listener's current position, in distance units.

'##PD x Value that represent the coordinates of the listener's new position vector. <i><b>Note:</b> that DirectSound may adjust these values to prevent floating-point overflow.</i>
'##PD y Value that represent the coordinates of the listener's new position vector. <i><b>Note:</b> that DirectSound may adjust these values to prevent floating-point overflow.</i>
'##PD z Value that represent the coordinates of the listener's new position vector. <i><b>Note:</b> that DirectSound may adjust these values to prevent floating-point overflow.</i>
    Call DSListener3D.SetPosition(x, y, z, DS3D_IMMEDIATE)
End Sub

Public Property Get Position() As D3DVECTOR
Attribute Position.VB_HelpID = 2494
Attribute Position.VB_Description = "Retrieves the listener's current position in distance units."

'##BD Retrieves the listener's current position in distance units.
    Call DSListener3D.GetPosition(Position) 'Get position
End Property
Public Sub SetOrientation(ByVal xf As Single, ByVal yf As Single, ByVal zf As Single, ByVal xt As Single, _
                                                                ByVal yt As Single, ByVal zt As Single)
Attribute SetOrientation.VB_HelpID = 2495
Attribute SetOrientation.VB_Description = "Sets the listener's current orientation in terms of two vectors: a front vector and a top vector."

'##BD Sets the listener's current orientation in terms of two vectors: a front vector and a top vector.

'##PD xf Value that represent the coordinates of the front orientation vector.
'##PD yf Value that represent the coordinates of the front orientation vector.
'##PD zf Value that represent the coordinates of the front orientation vector.
'##PD xt Value that represent the coordinates of the top orientation vector.
'##PD yt Value that represent the coordinates of the top orientation vector.
'##PD zt Value that represent the coordinates of the top orientation vector.
    Call DSListener3D.SetOrientation(xf, yf, zf, xt, yt, zt, DS3D_IMMEDIATE)
End Sub

Public Function GetOrientation(OrientationFront As D3DVECTOR, OrientationTop As D3DVECTOR)
Attribute GetOrientation.VB_HelpID = 2496
Attribute GetOrientation.VB_Description = "Retrieves the listener's current orientation in vectors: a front vector and a top vector."

'##BD Retrieves the listener's current orientation in vectors: a front vector and a top vector.
    
'##PD OrientationFront A D3DVECTOR type that will contain the listener's front orientation vector. Return Value
'##PD OrientationTop A D3DVECTOR type that will contain the listener's top orientation vector. Return Value
    Call DSListener3D.GetOrientation(OrientationFront, OrientationTop)
End Function

