VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MIDI8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
'##CD This object represents an loaded MID file.
Attribute VB_HelpID=2205
Attribute VB_Description="This object represents an loaded MID file."
Option Explicit

Public Key As String

Private mvarMusicSegment As DirectMusicSegment8
Private mvarSegmentState As DirectMusicSegmentState8
Private mvarName_ As String
Private mvarLength As Long
Private mvarStartingPoint As Long
Private mvarRepeats As Long

Attribute Key.VB_VarHelpID = 2208
Public Property Let Repeats(ByVal vData As Long)
Attribute Repeats.VB_HelpID = 2209
Attribute Repeats.VB_Description = "Returns/sets the number of times that the looping portion of the segment is to repeat.  "
    mvarRepeats = vData
    Call mvarMusicSegment.SetRepeats(mvarRepeats)
End Property

Public Property Get Repeats() As Long
'##BD Returns/sets the number of times that the looping portion of the segment is to repeat.
    mvarRepeats = mvarMusicSegment.GetRepeats
    Repeats = mvarRepeats
End Property

Public Property Let StartingPoint(ByVal vData As Long)
Attribute StartingPoint.VB_HelpID = 2210
Attribute StartingPoint.VB_Description = "Returns/sets the point at which the segment starts playing.  "
    mvarStartingPoint = vData
    Call mvarMusicSegment.SetStartPoint(mvarStartingPoint)
End Property

Public Property Get StartingPoint() As Long
'##BD Returns/sets the point at which the segment starts playing.
    mvarStartingPoint = mvarMusicSegment.GetStartPoint
    StartingPoint = mvarStartingPoint
End Property

Public Sub PlayMusic(Optional ByVal Flags As CONST_DMUS_SEGF_FLAGS = DMUS_SEGF_DEFAULT, _
                                        Optional ByVal Start As Long = 0)
Attribute PlayMusic.VB_HelpID = 2211
Attribute PlayMusic.VB_Description = "Plays the mid file."
'##BD Plays the mid file.

'##PD Flags Behavior options.
'##PD Start Time at which to begin playing the segment. <i>Default value is zero for ASAP.</i>
    On Error GoTo Handler

    If SEngine.Music.MusicPerformanceObject Is Nothing Then Exit Sub

    Set mvarSegmentState = SEngine.Music.MusicPerformanceObject.PlaySegmentEx(mvarMusicSegment, Flags, Start)
    Call SEngine.FireEvents(4, , Me)
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "MIDI | PlayMusic")
End Sub

Public Sub StopMusic()
Attribute StopMusic.VB_HelpID = 2212
Attribute StopMusic.VB_Description = "Stops playback."
'##BD Stops playback.
    On Error GoTo Handler

    If SEngine.Music.MusicPerformanceObject Is Nothing Then Exit Sub

    Call SEngine.Music.MusicPerformanceObject.StopEx(mvarMusicSegment, 0, 0)
    Call SEngine.FireEvents(5, , Me)
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "MIDI | StopMusic")
End Sub

Public Property Let Name_(ByVal vData As String)
Attribute Name_.VB_HelpID = 2213
Attribute Name_.VB_UserMemId = 0
Attribute Name_.VB_Description = "Returns/sets the name of the MIDI object. For reference purposes only.  "
    mvarName_ = vData
End Property

Public Property Get Name_() As String
'##BD Returns/sets the name of the MIDI object. <i>For reference purposes only.</i>
    Name_ = mvarName_
End Property

Public Property Get MusicSegmentObject() As DirectMusicSegment8
Attribute MusicSegmentObject.VB_HelpID = 2214
Attribute MusicSegmentObject.VB_Description = "Returns the DirectMusicSegment8 object. Use this property for custom operations."
'##BD Returns the DirectMusicSegment8 object. Use this property for custom operations.
    Set MusicSegmentObject = mvarMusicSegment
End Property

Friend Sub SetObjects(MSeg As DirectMusicSegment8)
Attribute SetObjects.VB_HelpID = 2215
    Set mvarMusicSegment = MSeg
End Sub

Public Property Get Length() As Long
Attribute Length.VB_HelpID = 2216
Attribute Length.VB_Description = "Returns/sets the length of the segment.  "
'##BD Returns/sets the length of the segment.
    mvarLength = mvarMusicSegment.GetLength
    Length = mvarLength
End Property

Public Property Let Length(ByVal vData As Long)
    mvarLength = vData
    Call mvarMusicSegment.SetLength(mvarLength)
End Property
