VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MIDIS8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"MIDI"
Attribute VB_Ext_KEY = "Member0" ,"MIDI"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Collection of MIDI objects.
Attribute VB_HelpID=2193
Attribute VB_Description="Collection of MIDI objects."
Option Explicit

'local variable to hold collection
Private mCol As Collection

Friend Function Add(Key As String, ByVal Name As String, Optional sKey As String) As MIDI8
Attribute Add.VB_HelpID = 2196
    'create a new object
    Dim objNewMember As MIDI8
    Set objNewMember = New MIDI8

    'set the properties passed into the method
    objNewMember.Key = Key
    objNewMember.Name_ = Name

    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As MIDI8
Attribute Item.VB_HelpID = 2197
Attribute Item.VB_UserMemId = 0
    Set Item = mCol(vntIndexKey)
End Property

Public Sub Clear()
Attribute Clear.VB_HelpID = 2198
Attribute Clear.VB_Description = "Removes all MIDI objects from the collection."
'##BD Removes all MIDI objects from the collection.
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub

Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2199
Attribute Count.VB_Description = "Total number of MIDI objects within the collection."
'##BD Total number of MIDI objects within the collection.
    Count = mCol.Count
End Property

Public Function LoadMidi(ByVal FileName As String, ByVal Name As String) As MIDI8
Attribute LoadMidi.VB_HelpID = 2200
Attribute LoadMidi.VB_Description = "Loads a mid file for playing."
'##BD Loads a mid file for playing.

'##PD FileName Name of the mid file to load. <i><b>Note:</b> You must set the search directory on the Music object to use this method.</i>
    Dim Seg As DirectMusicSegment8, lCount As Long
    On Error GoTo Handler

'    Call TestPakFile(FileName)
    Set Seg = SEngine.Music.MusicLoaderObject.LoadSegment(FileName) 'Create the music segment
'    Call DeleteTempPAK

    lCount = Count + 1
    Set LoadMidi = Add(CStr(lCount), Name, Name) 'Create a new MIDI class.
    Call Seg.SetStandardMidiFile
    Call LoadMidi.SetObjects(Seg) 'set the new music segment in our MIDI object.

    Call SEngine.FireEvents(6, , LoadMidi)
    
ExitIt:
    Set Seg = Nothing
    Exit Function

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "MIDIS | LoadMidi")
    GoTo ExitIt
End Function

Public Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_HelpID = 2201
Attribute Remove.VB_Description = "Removes a MIDI object from the collection."
'##BD Removes a MIDI object from the collection.
    Call mCol.Remove(vntIndexKey)
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2202
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

