VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MP38"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "MP3 class allows the playing of MP3 and WMA files."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD MP3 class allows the playing of MP3 and WMA files.
Attribute VB_HelpID=2420
Attribute VB_Description="MP3 class allows the playing of MP3 and WMA files."
Option Explicit

Private mvarMP3File As String

'Privates
Private AliasName As String 'Holds the alias name for the opened file.
Private Result As String

Public Type MP3Info
    '##UDT_DESCRIPTION MP3 File Information.
    '##UDT_MEMBER_DESCRIPTION Frequency Frequency was created using.
    '##UDT_MEMBER_DESCRIPTION MpegVersion Version was created with.
    '##UDT_MEMBER_DESCRIPTION Duration Length.
    '##UDT_MEMBER_DESCRIPTION CopyRight Legal right information.
    '##UDT_MEMBER_DESCRIPTION HasTag MP3 file has a associated tag.
    '##UDT_MEMBER_DESCRIPTION Tag Tag information.
    '##UDT_MEMBER_DESCRIPTION SongName Name of the song.
    '##UDT_MEMBER_DESCRIPTION Artist Name of the artist performing.
    '##UDT_MEMBER_DESCRIPTION Album Name of the album the MP3 is from.
    '##UDT_MEMBER_DESCRIPTION Year Year published.
    '##UDT_MEMBER_DESCRIPTION Comment Comment text.
    '##UDT_MEMBER_DESCRIPTION Genre Genre id the MP3 is from.
    '##UDT_MEMBER_DESCRIPTION Track Track information.
    Bitrate As Integer
    Frequency As Long
    Mode As String
    Emphasis As String
    'ModeExtension As String
    MpegVersion As Integer
    MpegLayer As Integer
    Padding As String
    CRC As String
    Duration As Long
    CopyRight As String
    Original As String
    PrivateBit As String
    HasTag As Boolean
    Tag As String
    SongName As String
    Artist As String
    Album As String
    Year As String
    Comment As String
    Genre As Integer
    Track As String
    VBR As Boolean
    Frames As Integer
End Type
Public Function LoadMP3File(ByVal hWnd As Long, Optional file As String) As Boolean
Attribute LoadMP3File.VB_HelpID = 2423
Attribute LoadMP3File.VB_Description = "Loads a MP3 into the SoundEngine."
'##BD Loads a MP3 into the SoundEngine.

'##PD hWnd Handle to the parent window.
'##PD File Name and location of the MP3 file to load.
'##RD True if MP3 is loaded successfully | False if an error is generated.
    Dim cmdToDo As String * 255, dwReturn As Long, ret As String * 128
    Dim tmp As String * 255, lenShort As Long, ShortPathAndFile As String
    Dim sError As String
    Const WS_CHILD = &H40000000
    On Error GoTo Handler

    'Determine if the user passed in the file or they set the property first.
    If (mvarMP3File = "") And (file = "") Then
        Exit Function
    ElseIf (mvarMP3File = "") Or (file <> "") Then
        mvarMP3File = file
    ElseIf (mvarMP3File <> "") Or (file = "") Then
        file = mvarMP3File
    End If

    DoEvents

Again:
    AliasName = "mpeg" & GetRandomNumber(1000, 1) 'Make a alias name

    'Open the MPEG.
    lenShort = GetShortPathName(file, tmp, 255) 'Get short path name.
    ShortPathAndFile = Left$(tmp, lenShort) 'cut short path from buffer
    'Get command string
    cmdToDo = "open " & ShortPathAndFile & " type MPEGVideo" & " Alias " & AliasName & " parent " & hWnd & " Style " & WS_CHILD
    dwReturn = mciSendString(cmdToDo, 0&, 0&, 0&) 'Send command string.

    'Check success
    If Not dwReturn = 0 Then
        'not success
        Call mciGetErrorString(dwReturn, ret, 128)   'Get the error
        Err.Description = Trim$(ret): Err.Number = dwReturn
        GoTo Handler

    Else
        'Successful.
        Dim LbFramesPerSecond As Variant, LbTotalFrames As Variant, LbTotalTime As Variant

        LbFramesPerSecond = GetFramesPerSecond(AliasName)
        LbTotalFrames = GetTotalframes(AliasName)  'Get total frames
        LbTotalTime = GetTotalTimeByMS(AliasName) / 1000   'Get Total Time
        Call ReadMP3(file, True, True)

        'Raise event
        LoadMP3File = True
        Call SEngine.FireEvents(9, , , mvarMP3File)
    End If
    Exit Function

Handler:
    LoadMP3File = False
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "MP3 | LoadMP3File Function")
End Function

Public Function PlayMP3(Optional from_where As String = "0", Optional to_where As String = "") As Boolean
Attribute PlayMP3.VB_HelpID = 2424
Attribute PlayMP3.VB_Description = "Plays the loaded MP3 file."
'##BD Plays the loaded MP3 file.

'##PD from_where Starting point.
'##PD to_where 'Ending point.
'##RD True if MP3 starts to play | False if a error is generated.
    Dim cmdToDo As String * 128
    Dim dwReturn As Long
    Dim ret As String * 128

    If from_where = vbNullString Then from_where = 0
    If to_where = vbNullString Then to_where = GetTotalframes(AliasName)

    cmdToDo = "play " & AliasName & " from " & from_where & " to " & to_where
    dwReturn = mciSendString(cmdToDo, 0&, 0&, 0&) 'play

    If Not dwReturn = 0 Then 'not success
        Call mciGetErrorString(dwReturn, ret, 128)  'get the error
        PlayMP3 = False
        Exit Function
    End If

    'Success
    PlayMP3 = True
End Function

Public Property Get CurrentTime() As String
Attribute CurrentTime.VB_HelpID = 2521
Attribute CurrentTime.VB_Description = "Returns the current time at which the MP3 file is playing at. For example: 11554."
'##BD Returns the current time at which the MP3 file is playing at. <b>For example: 11554.</b>
    Dim s As String * 30
    On Error GoTo Handler

    Call mciSendString("status " & AliasName & " position", s, Len(s), 0) 'Grab position information.
    CurrentTime = format$(s) 'format$(s, "##:##")
    Exit Property

Handler:
    CurrentTime = "00:00"
End Property

Public Property Get MP3Length() As String
Attribute MP3Length.VB_HelpID = 2522
Attribute MP3Length.VB_Description = "Returns the length of the MP3 file."
'##BD Returns the length of the MP3 file.
    Dim s As String * 30

    Call mciSendString("status " & AliasName & " length wait", s, Len(s), 0)
    MP3Length = Replace(s, Chr(0), "")
End Property
Public Sub StopMP3()
Attribute StopMP3.VB_HelpID = 2425
Attribute StopMP3.VB_Description = "Stops a MP3 from playing."
'##BD Stops a MP3 from playing.
    Dim dwReturn As Long
    Dim ret As String * 128

    dwReturn = mciSendString("Stop " & AliasName, 0&, 0&, 0&) 'stop

    If Not dwReturn = 0 Then  'not success
        Call mciGetErrorString(dwReturn, ret, 128)  'Get the error
        Exit Sub
    End If
End Sub

Public Sub PauseMP3()
Attribute PauseMP3.VB_HelpID = 2426
Attribute PauseMP3.VB_Description = "Pauses the MP3."
'##BD Pauses the MP3.
    Dim dwReturn As Long, ret As String * 128

    dwReturn = mciSendString("Pause " & AliasName, 0&, 0&, 0&) 'pause

    If Not dwReturn = 0 Then  'not success
        Call mciGetErrorString(dwReturn, ret, 128)
        Exit Sub
    End If
End Sub

Public Sub ResumeMP3()
Attribute ResumeMP3.VB_HelpID = 2427
Attribute ResumeMP3.VB_Description = "Resumes play of a paused MP3"
'##BD Resumes play of a paused MP3
    Dim dwReturn As Long
    Dim ret As String * 128

    dwReturn = mciSendString("Resume " & AliasName, 0&, 0&, 0&) 'Resume

    If Not dwReturn = 0 Then  'not success
        Call mciGetErrorString(dwReturn, ret, 128)  'Get the error
        Exit Sub
    End If
End Sub
Public Property Get MP3File() As String
Attribute MP3File.VB_HelpID = 2428
Attribute MP3File.VB_Description = "Returns/sets the MP3 to load or is loaded.  "
'##BD Returns/sets the MP3 to load or is loaded.
    MP3File = mvarMP3File
End Property

Public Property Let MP3File(ByVal vData As String)
    mvarMP3File = vData
End Property

Public Property Get Information() As MP3Info
Attribute Information.VB_HelpID = 2429
Attribute Information.VB_Description = "Returns the loaded MP3 information."
'##BD Returns the loaded MP3 information.
    Information = GetMP3Info
End Property

Private Sub Class_Terminate()
    Call StopMP3 'Make sure it's stop playing before we go.
End Sub


