VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Music8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"MP3"
Attribute VB_Ext_KEY = "Member1" ,"CD"
Attribute VB_Ext_KEY = "Member2" ,"MIDIS"
'##CD This object controls all aspects of music.

Attribute VB_HelpID=2027
Attribute VB_Description="This object controls all aspects of music."
' DirectMusic8 class
' Christopher D. Parker

'12-12-00 : First release

Private mvarMusicLoader As DirectMusicLoader8
Private mvarMusicPerf As DirectMusicPerformance8
Private mvarMIDIS As MIDIS8
Private mvarCD As CD8
Private mvarMP3 As MP38

Public Sub SetGrooveLevel(ByVal Level As Integer)
Attribute SetGrooveLevel.VB_HelpID = 2157
Attribute SetGrooveLevel.VB_Description = "Sets the over-all groove level"
'##BD Sets the over-all groove level

'##PD Level New groove level.
    If mvarMusicPerf Is Nothing Then Exit Sub

    Call mvarMusicPerf.SetMasterGrooveLevel(Level)
End Sub

Friend Sub SetLoaderAndPerfomanceObjects(Perf As DirectMusicPerformance8, Loader As DirectMusicLoader8)
Attribute SetLoaderAndPerfomanceObjects.VB_HelpID = 2158
    Set mvarMusicPerf = Perf
    Set mvarMusicLoader = Loader
End Sub

Public Sub SetTempo(ByVal Tempo As Single)
Attribute SetTempo.VB_HelpID = 2032
Attribute SetTempo.VB_Description = "Sets the over-all tempo."
'##BD Sets the over-all tempo.

'##PD Tempo New tempo.
    If mvarMusicPerf Is Nothing Then Exit Sub

    Call mvarMusicPerf.SetMasterTempo(Tempo)
End Sub

Public Sub SetVolume(ByVal Volume As Single)
Attribute SetVolume.VB_HelpID = 2034
Attribute SetVolume.VB_Description = "Sets the over-all volume."
'##BD Sets the over-all volume.

'##PD Volume New volume.
    If mvarMusicPerf Is Nothing Then Exit Sub

    Call mvarMusicPerf.SetMasterVolume(Volume)
End Sub



Public Property Get MusicLoaderObject() As DirectMusicLoader8
Attribute MusicLoaderObject.VB_HelpID = 2159
Attribute MusicLoaderObject.VB_Description = "Returns the DirectMusicLoader object. Use this object for custom operations."
'##BD Returns the DirectMusicLoader object. Use this object for custom operations.
    Set MusicLoaderObject = mvarMusicLoader
End Property

Public Property Get MusicPerformanceObject() As DirectMusicPerformance8
Attribute MusicPerformanceObject.VB_HelpID = 2160
Attribute MusicPerformanceObject.VB_Description = "Returns the DirectMusicPerformance object. Use this object for custom operations."
'##BD Returns the DirectMusicPerformance object. Use this object for custom operations.
    Set MusicPerformanceObject = mvarMusicPerf
End Property

Public Property Let SearchDirectory(ByVal vData As String)
Attribute SearchDirectory.VB_HelpID = 2161
Attribute SearchDirectory.VB_Description = "Sets the directory DirectMusic should look in when load mid files."
'##BD Sets the directory DirectMusic should look in when load mid files.
    Call mvarMusicLoader.SetSearchDirectory(vData)
End Property

Private Sub Class_Initialize()
    Set mvarMIDIS = New MIDIS8
    Set mvarCD = New CD8
    Set mvarMP3 = New MP38
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    Call mvarMusicPerf.CloseDown

    Set mvarMusicLoader = Nothing
    Set mvarMusicPerf = Nothing
    Set mvarMIDIS = Nothing
    Set mvarCD = Nothing
    Set mvarMP3 = Nothing
End Sub

Public Property Get MIDIS() As MIDIS8
Attribute MIDIS.VB_HelpID = 2164
Attribute MIDIS.VB_Description = "Returns a collection of loaded MIDI objects."
'##BD Returns a collection of loaded MIDI objects.
    Set MIDIS = mvarMIDIS
End Property

Public Property Get CD() As CD8
Attribute CD.VB_HelpID = 2517
    Set CD = mvarCD
End Property

Public Property Get MP3() As MP38
Attribute MP3.VB_HelpID = 2518
    Set MP3 = mvarMP3
End Property

