VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoundDevices8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"SoundDevice"
Attribute VB_Ext_KEY = "Member0" ,"SoundDevice"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Collection of SoundDevice objects.
Attribute VB_HelpID=2048
Attribute VB_Description="Collection of SoundDevice objects."
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private Sub Clear()
Attribute Clear.VB_HelpID = 2051
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub

Friend Function Add(Key As String, Description As String, Guid As String, Name_ As String, DType As eSoundDeviceTypes, _
                                        Optional sKey As String) As SoundDevice8
    'create a new object
    Dim objNewMember As SoundDevice8
    Set objNewMember = New SoundDevice8

    'set the properties passed into the method
    With objNewMember
        .Key = Key
        Call .SetInformation(Description, Guid, Name_, DType)
    End With

    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As SoundDevice8
Attribute Item.VB_HelpID = 2053
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_Description = "Returns a SoundDevice8 object using it's key property."
'##BD Returns a SoundDevice8 object using it's key property.
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2054
Attribute Count.VB_Description = "Total number of SoundDevices within the collection."
'##BD Total number of SoundDevices within the collection.
    Count = mCol.Count
End Property

Public Sub RefreshSoundDevices()
Attribute RefreshSoundDevices.VB_HelpID = 2055
Attribute RefreshSoundDevices.VB_Description = "Reloads the collection with all sound devices on the current machine."
'##BD Reloads the collection with all sound devices on the current machine.
    Dim DSEnum As DirectSoundEnum8, lCount As Long, SD As SoundDevice8, lCount2 As Long
    On Error GoTo Handler

    Call Clear 'Clear the collection
    
    'Get the Sound Devices first.=========================================
    Set DSEnum = DirectX.GetDSEnum
    If DSEnum Is Nothing Then GoTo ExitIt

    lCount = 1
    Do Until lCount > DSEnum.GetCount
        Set SD = Add(CStr(lCount), DSEnum.GetDescription(lCount), DSEnum.GetGuid(lCount), DSEnum.GetName(lCount), _
                                seSoundDevice, CStr(lCount))
        lCount = lCount + 1
    Loop
    
    'Get the Capture Devices next.=========================================
    Set DSEnum = DirectX.GetDSCaptureEnum
    If DSEnum Is Nothing Then GoTo ExitIt
    
    lCount2 = 1
    Do Until lCount2 > DSEnum.GetCount
        Set SD = Add(CStr(lCount), DSEnum.GetDescription(lCount2), DSEnum.GetGuid(lCount2), DSEnum.GetName(lCount2), _
                                seCaptureDevice, CStr(lCount))
        lCount = lCount + 1
        lCount2 = lCount2 + 1
    Loop
    
ExitIt:
    Set DSEnum = Nothing:    Set SD = Nothing
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "SoundDevices8 | RefreshSoundDevices")
    GoTo ExitIt
End Sub

Friend Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_HelpID = 2056
    Call mCol.Remove(vntIndexKey)
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2057
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

