VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoundEngine8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"MP3"
Attribute VB_Ext_KEY = "Member1" ,"MP3"
Attribute VB_Ext_KEY = "Member2" ,"Music"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member3" ,"Sound"
Attribute VB_Ext_KEY = "Member4" ,"SoundDevices"
'##CD Top level object of the Sound Engine. All other objects are children of this object.
Attribute VB_HelpID=2068
Attribute VB_Description="Top level object of the Sound Engine. All other objects are children of this object."
'------------------------------------------------------------------------
' DirectSound
'------------------------------------------------------------------------
' Christopher D. Parker @ October 2000.
' Some code from Sylvain Dupont @ December 1999.
'
'
' TrueVision 3D http://www.truevision3d.com/
Option Explicit

'Events
Event OnError(ErrNum As Long, ErrDescription As String, ErrLocation As String)
Attribute OnError.VB_HelpID = 2069
Attribute OnError.VB_Description = "Fires when an error occurs."
'##ED Fires when an error occurs.
'##PD ErrNum Error number.
'##PD ErrDescription Error Description.
'##PD ErrLocation Location (Class and Method/Property) the error occured in.

Event Initialized()
Attribute Initialized.VB_HelpID = 2177
Attribute Initialized.VB_Description = "Fires when the SoundEngine has been initialized."
'##ED Fires when the SoundEngine has been initialized.

Event WaveFileLoaded(Wave As Wave8)
Attribute WaveFileLoaded.VB_HelpID = 2501
Attribute WaveFileLoaded.VB_Description = "Fires when a wave file is loaded."
'##ED Fires when a wave file is loaded.
'##PD Wave Wave class representing the newly loaded wave file.

Event WavePlaying(Wave As Wave8)
Attribute WavePlaying.VB_HelpID = 2502
Attribute WavePlaying.VB_Description = "Fires when a wave file starts to play."
'##ED Fires when a wave file starts to play.
'##PD Wave Wave class representing the playing wave file.

Event WaveStopped(Wave As Wave8)
Attribute WaveStopped.VB_HelpID = 2503
Attribute WaveStopped.VB_Description = "Fires when a wave file is stopped."
'##ED Fires when a wave file is stopped.
'##PD Wave Wave class representing the stopped wave file.

Event MIDIPlaying(MIDI As MIDI8)
Attribute MIDIPlaying.VB_HelpID = 2504
Attribute MIDIPlaying.VB_Description = "Fires when a MIDI file starts to play."
'##ED Fires when a MIDI file starts to play.
'##PD MIDI MIDI class representing the playing mid file.

Event MIDIStopped(MIDI As MIDI8)
Attribute MIDIStopped.VB_HelpID = 2505
Attribute MIDIStopped.VB_Description = "Fires when a MIDI file is stopped."
'##ED Fires when a MIDI file is stopped.
'##PD MIDI MIDI class representing the stopped mid file.

Event MIDIFileLoaded(MIDI As MIDI8)
Attribute MIDIFileLoaded.VB_HelpID = 2506
Attribute MIDIFileLoaded.VB_Description = "Fires when a mid file is loaded."
'##ED Fires when a mid file is loaded.
'##PD MIDI MIDI class representing the newly loaded mid file.

Event CDOpen()
Attribute CDOpen.VB_HelpID = 2392
Attribute CDOpen.VB_Description = "Fires when the CD tray is opened using the OpenCDTray method.."
'##ED Fires when the CD tray is opened using the OpenCDTray method..

Event CDEjected()
Attribute CDEjected.VB_HelpID = 2393
Attribute CDEjected.VB_Description = "Fires when the CD tray is closed using the CloseCDTray method.."
'##ED Fires when the CD tray is closed using the CloseCDTray method..

Event MP3FileLoaded(ByVal MP3File As String)
Attribute MP3FileLoaded.VB_HelpID = 2507
Attribute MP3FileLoaded.VB_Description = "Fires when a MP3 file is loaded."
'##ED Fires when a MP3 file is loaded.
'##PD MP3File - Path to the MP3 file loaded.

Event CDPlaying()
Attribute CDPlaying.VB_HelpID = 2395
Attribute CDPlaying.VB_Description = "Fires when the CD has started to play."
'##ED Fires when the CD has started to play.

Event CDStopPlaying()
Attribute CDStopPlaying.VB_HelpID = 2396
Attribute CDStopPlaying.VB_Description = "Fires when the CD has stop playing."
'##ED Fires when the CD has stop playing.

Event CDPaused()
Attribute CDPaused.VB_HelpID = 2397
Attribute CDPaused.VB_Description = "Fires when the CD is paused."
'##ED Fires when the CD is paused.

Event CDROMInitialized()
Attribute CDROMInitialized.VB_HelpID = 2475
Attribute CDROMInitialized.VB_Description = "Fires when the CDROM has been initialized for use."
'##ED Fires when the CDROM has been initialized for use.

'local variable(s) to hold property value(s)
Private mvarSoundDevices As SoundDevices8
Private mvarVersion As String
Private mvarSound As Sound8
Private mvarMusic As Music8
Private mvarDS As DirectSound8
Private mvarTrueVision As TrueVision8

Friend Sub FireEvents(ByVal lEvent As Long, Optional Wave As Wave8, Optional MIDI As MIDI8, Optional ByVal MP3File As String)
    Select Case lEvent
        Case 1 'WaveFileLoaded
            RaiseEvent WaveFileLoaded(Wave)

        Case 2 'WavePlaying
            RaiseEvent WavePlaying(Wave)

        Case 3 'WaveStopped
            RaiseEvent WaveStopped(Wave)

        Case 4 'MIDIPlaying
            RaiseEvent MIDIPlaying(MIDI)

        Case 5 'MIDIStopped
            RaiseEvent MIDIStopped(MIDI)

        Case 6 'MIDIFileLoaded
            RaiseEvent MIDIFileLoaded(MIDI)

        Case 7 'CDTrayOpen
            RaiseEvent CDOpen

        Case 8 'CDTrayClosed
            RaiseEvent CDEjected

        Case 9 'MP3FileLoaded
            RaiseEvent MP3FileLoaded(MP3File)

        Case 10 'CDPlaying
            RaiseEvent CDPlaying

        Case 11 'CDStopPlaying
            RaiseEvent CDStopPlaying

        Case 12 'CDPaused
            RaiseEvent CDPaused

        Case 13 'CDROMInitialized
            RaiseEvent CDROMInitialized
    End Select
End Sub

Public Function InitalizeSound(Optional Device As String = vbNullString, _
                                            Optional ByVal CoOp As CONST_DSSCLFLAGS = DSSCL_NORMAL) As Boolean
Attribute InitalizeSound.VB_HelpID = 2451
Attribute InitalizeSound.VB_Description = "Initalizes DirectSound for use by the SoundEngine. This method must be called first before performing any operations on the SoundEngine."
'##BD Initalizes DirectSound for use by the SoundEngine. This method must be called first before performing any operations on the SoundEngine.

'##PD Device GUID of the sound device you wish to use. You can retrieve a list of all sound devices from the SoundDevices collection.
'##CoOp Cooperation level you wish to set DirectSound at.
    On Error GoTo Handler

    'Initialize DirectSound Stuff.
    Set mvarDS = DirectX.DirectSoundCreate(Device)

    Call mvarDS.SetCooperativeLevel(Form1.hWnd, CoOp)
    Desc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER

    Set DSPrimary = mvarDS.CreatePrimarySoundBuffer(Desc)
    Call DSPrimary.Play(DSBPLAY_LOOPING)
    With Sound.Listener 'Set properties of the Listener class.
        Set .SoundBuffer3DListener = DSPrimary.GetDirectSound3DListener()
        .RolloffFactor = 5
        Call .SetVelocity(3, 2, 0)
        Call .SetPosition(0, 0, 0)
        .DopplerFactor = 1
        Call .SetOrientation(0, 0, 1, 0, 1, 0)
    End With

    InitalizeSound = True
    RaiseEvent Initialized
    Exit Function

Handler:
    RaiseEvent OnError(Err.Number, Err.Description, "SoundEngine | InitalizeSound Function")
    InitalizeSound = False
End Function

Public Function InitalizeMusic(ByVal SearchDirectory As String) As Boolean
Attribute InitalizeMusic.VB_HelpID = 2508
Attribute InitalizeMusic.VB_Description = "Initalizes DirectMusic for use by the SoundEngine. This method must be called first before performing any operations on the SoundEngine."
'##BD Initalizes DirectMusic for use by the SoundEngine. This method must be called first before performing any operations on the SoundEngine.

'##PD Device GUID of the sound device you wish to use. You can retrieve a list of all sound devices from the SoundDevices collection.
'##CoOp Cooperation level you wish to set DirectMusic at.
    Dim Loader As DirectMusicLoader8, Perf As DirectMusicPerformance8, dAPS As DMUS_AUDIOPARAMS
    On Error GoTo Handler

    'Initialize DirectMusic Stuff.
    Set Loader = DirectX.DirectMusicLoaderCreate 'Create Music Loader.
    Call Loader.SetSearchDirectory(SearchDirectory)
    
    'Set some initial properties for the performance object.
    Set Perf = DirectX.DirectMusicPerformanceCreate 'Create performance object.
    Call Perf.InitAudio(0, DMUS_AUDIOF_ALL, dAPS, mvarDS, DMUS_APATH_SHARED_STEREOPLUSREVERB, 64)
    Call Perf.SetMasterAutoDownload(True)
    Call mvarMusic.SetLoaderAndPerfomanceObjects(Perf, Loader) 'Set the objects in the music class.

    InitalizeMusic = True
    RaiseEvent Initialized

ExitIt:
    Set Loader = Nothing
    Set Perf = Nothing
    Exit Function

Handler:
    RaiseEvent OnError(Err.Number, Err.Description, "SoundEngine | InitalizeMusic Function")
    InitalizeMusic = False
    GoTo ExitIt
End Function
Public Property Get Music() As Music8
Attribute Music.VB_HelpID = 2509
Attribute Music.VB_Description = "Returns the Music object."
'##BD Returns the Music object.
    Set Music = mvarMusic
End Property

Public Property Get Sound() As Sound8
Attribute Sound.VB_HelpID = 2510
Attribute Sound.VB_Description = "Returns the Sound object."
'##BD Returns the Sound object.
    Set Sound = mvarSound
End Property

Public Property Get Version() As String
Attribute Version.VB_HelpID = 2080
Attribute Version.VB_MemberFlags = "200"
Attribute Version.VB_Description = "Returns the version string of the Sound Engine."
'##BD Returns the version string of the Sound Engine.
    Version = mvarVersion
End Property

Public Property Get SoundDevices() As SoundDevices8
Attribute SoundDevices.VB_HelpID = 2081
Attribute SoundDevices.VB_Description = "Returns the collection of SoundDevice objects."
'##BD Returns the collection of SoundDevice objects.
    Set SoundDevices = mvarSoundDevices
End Property

Private Sub Class_Initialize()
    Set SEngine = Me
    Set DirectX = New DxVBLibA.DirectX8

    mvarVersion = CStr(App.Major & "." & App.Minor & "." & App.Revision)
    Set mvarMusic = New Music8
    Set mvarSound = New Sound8
    Set mvarSoundDevices = New SoundDevices8

    Call mvarSoundDevices.RefreshSoundDevices
End Sub

Property Get TrueVision3DObject() As TrueVision8
Attribute TrueVision3DObject.VB_HelpID = 2281
Attribute TrueVision3DObject.VB_Description = "Returns/Sets the TrueVision 3D engine "TrueVision" class. This property is used to allow the SoundEngine to use pak files for loading sound and also to link the engines together. Note: This property must be set to use pak files with this engine. Set the TrueVision object so that you can use some functionnalities of the 3D Engine (PAK files...)Set the TrueVision object so that you can use some functionnalities of the 3D Engine (PAK files...)"
'##BD Returns/Sets the TrueVision 3D engine "TrueVision" class. This property is used to allow the SoundEngine to use pak files for _
loading sound and also to link the engines together. <i><b>Note:</b> This property must be set to use pak files with this engine.</i>
    Set TrueVision3DObject = mvarTrueVision
End Property

Property Set TrueVision3DObject(TV As TrueVision8)
'##BD Set the TrueVision object so that you can use some functionnalities of the 3D Engine (PAK files...)
'##PD TV TrueVision object in your app.
    Set mvarTrueVision = TV

    'Get the FileOp
'    Set FileOp = TV.FileOperation
End Property

Friend Sub FireErrorEvent(ByVal ErrNum As Long, ByVal ErrDesc As String, ByVal ErrLoc As String)
Attribute FireErrorEvent.VB_HelpID = 2083
    RaiseEvent OnError(ErrNum, ErrDesc, ErrLoc)
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    
    Set mvarMusic = Nothing
    Set mvarSound = Nothing
    Set mvarSoundDevices = Nothing
    Set mvarTrueVision = Nothing
    Set DSListener3D = Nothing
    Set DSPrimary = Nothing
    Set SEngine = Nothing
'    Set FileOp = Nothing

    Call mvarDS.SetCooperativeLevel(Form1.hWnd, DSSCL_NORMAL)
    Set mvarDS = Nothing
    Set DirectX = Nothing
End Sub

Public Property Get DirectSoundObject() As DirectSound8
Attribute DirectSoundObject.VB_HelpID = 2085
Attribute DirectSoundObject.VB_Description = "Returns the DirectSound object. Use this object for custom operations."
'##BD Returns the DirectSound object. Use this object for custom operations.
    Set DirectSoundObject = mvarDS
End Property
