VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Wave8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
'##CD This object represents a wave file loaded into memory for playing.
Attribute VB_HelpID=2101
Attribute VB_Description="This object represents a wave file loaded into memory for playing."
Option Explicit

Public Key As String

'local variable(s) to hold property value(s)
Private mvarName_ As String
Private mvarPath As String
Private mvarSoundBuffer As DirectSoundSecondaryBuffer8
Private mvarSoundBuffer3D As DirectSound3DBuffer8
Private mvarPan As Long

Attribute Key.VB_VarHelpID = 2104
Public Property Get Capabilities() As DSBCAPS
Attribute Capabilities.VB_HelpID = 2145
Attribute Capabilities.VB_Description = "Returns the capabilities of this wave file's sound buffer."
'##BD Returns the capabilities of this wave file's sound buffer.
    Call mvarSoundBuffer.GetCaps(Capabilities)
End Property

Public Property Let Frequency(Frequency As Long)
Attribute Frequency.VB_HelpID = 2105
Attribute Frequency.VB_Description = "Returns/sets the frequency, in samples per second, at which the buffer is played.  "
    Call mvarSoundBuffer.SetFrequency(Frequency)
End Property

Public Sub GetConeAngles(RetInCone As Long, RetOutCone As Long)
Attribute GetConeAngles.VB_HelpID = 2476
Attribute GetConeAngles.VB_Description = "Retrieves the inside and outside angles of the sound projection cone for this wave's sound buffer."

'##BD Retrieves the inside and outside angles of the sound projection cone for this wave's sound buffer.

'##PD RetInCone Return InCone value.
'##PD RetOutCone Return OutCone value.
    Call mvarSoundBuffer3D.GetConeAngles(RetInCone, RetOutCone)
End Sub



Public Property Get GetConeOrientation() As D3DVECTOR
Attribute GetConeOrientation.VB_HelpID = 2477
Attribute GetConeOrientation.VB_Description = "Retrieves the orientation of the sound projection cone for this wave's sound buffer."

'##BD Retrieves the orientation of the sound projection cone for this wave's sound buffer.
    Call mvarSoundBuffer3D.GetConeOrientation(GetConeOrientation)
End Property

Public Property Get Position() As D3DVECTOR
Attribute Position.VB_HelpID = 2478
Attribute Position.VB_Description = "Retrieves the sound buffer's current position, in distance units."

'##BD Retrieves the sound buffer's current position, in distance units.
    Call mvarSoundBuffer3D.GetPosition(Position)
End Property

Public Property Get Velocity() As D3DVECTOR
Attribute Velocity.VB_HelpID = 2479
Attribute Velocity.VB_Description = "Retrieves the sound buffer's current velocity, in distance units."

'##BD Retrieves the sound buffer's current velocity, in distance units.
    Call mvarSoundBuffer3D.GetPosition(Position)
End Property
Public Property Get ConeOutsideVolume() As Long
Attribute ConeOutsideVolume.VB_HelpID = 2480
Attribute ConeOutsideVolume.VB_Description = "Returns/sets the current cone outside volume  for this wave's sound buffer.  "

'##BD Returns/sets the current cone outside volume  for this wave's sound buffer.
    ConeOutsideVolume = mvarSoundBuffer3D.GetConeOutsideVolume
End Property

Public Property Let ConeOutsideVolume(ByVal vData As Long)
    Call mvarSoundBuffer3D.SetConeOutsideVolume(vData, DS3D_IMMEDIATE)
End Property
Public Property Get MaxDistance() As Long
Attribute MaxDistance.VB_HelpID = 2481
Attribute MaxDistance.VB_Description = "Returns/sets the current maximum distance for this wave's sound buffer.  "

'##BD Returns/sets the current maximum distance for this wave's sound buffer.
    MaxDistance = mvarSoundBuffer3D.GetMaxDistance
End Property

Public Property Let MaxDistance(ByVal vData As Long)
    Call mvarSoundBuffer3D.SetMaxDistance(vData, DS3D_IMMEDIATE)
End Property
Public Property Get MinDistance() As Long
Attribute MinDistance.VB_HelpID = 2482
Attribute MinDistance.VB_Description = "Returns/sets the current minimum distance for this wave's sound buffer.  "

'##BD Returns/sets the current minimum distance for this wave's sound buffer.
    MaxDistance = mvarSoundBuffer3D.GetMinDistance
End Property

Public Property Let MinDistance(ByVal vData As Long)
    Call mvarSoundBuffer3D.SetMinDistance(vData, DS3D_IMMEDIATE)
End Property
Public Property Get Mode() As CONST_DS3DMODEFLAGS
Attribute Mode.VB_HelpID = 2483
Attribute Mode.VB_Description = "Returns/sets the current operation mode for this wave's sound buffer.  "

'##BD Returns/sets the current operation mode for this wave's sound buffer.
    MaxDistance = mvarSoundBuffer3D.GetMode
End Property

Public Property Let Mode(ByVal vData As CONST_DS3DMODEFLAGS)
    Call mvarSoundBuffer3D.SetMode(vData, DS3D_IMMEDIATE)
End Property
Public Property Let Path(ByVal vData As String)
Attribute Path.VB_HelpID = 2106
Attribute Path.VB_Description = "Returns/sets the path this wave file is located.  "
    mvarPath = vData
End Property

Public Property Get Path() As String
'##BD Returns/sets the path this wave file is located.
    Path = mvarPath
End Property

Public Property Let Name_(ByVal vData As String)
Attribute Name_.VB_HelpID = 2107
Attribute Name_.VB_UserMemId = 0
Attribute Name_.VB_Description = "Returns/sets the name of the wave file.  "
    mvarName_ = vData
End Property

Public Property Get Name_() As String
'##BD Returns/sets the name of the wave file.
    Name_ = mvarName_
End Property

Public Function ReadBuffer(ByVal Start As Long, ByVal Size As Long, Optional ByVal Flags As CONST_DSBLOCKFLAGS = 0) As Variant
Attribute ReadBuffer.VB_HelpID = 2146
Attribute ReadBuffer.VB_Description = "Reads a segment of the wave's sound buffer."
'##BD Reads a segment of the wave's sound buffer.

'##PD Start Postion where the read buffer will begin.
'##PD Size Portion of the buffer to read. <b><i>Note:</b> That the sound buffer is conceptually circular.</i>
'##PD Flags Read options.
    On Error GoTo Handler

    Call mvarSoundBuffer.ReadBuffer(Start, Size, ReadBuffer, Flags)
    Exit Function

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Wave | Read")
End Function

Public Sub WriteBuffer(ByVal Start As Long, ByVal Size As Long, buffer As Variant, _
                                                    Optional ByVal Flags As CONST_DSBLOCKFLAGS = 0)
Attribute WriteBuffer.VB_HelpID = 2147
Attribute WriteBuffer.VB_Description = "Writes to a segment of the sound buffer."
'##BD Writes to a segment of the sound buffer.

'##PD Start Position to start writing at.
'##PD Size Portion of the buffer to read. Note that the sound buffer is conceptually circular.
'##PD Buffer Variable with the data to be written to the sound buffer
'##PD Flags Write options.
    On Error GoTo Handler

    Call mvarSoundBuffer.WriteBuffer(Start, Size, buffer, Flags)
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Wave | Read")
End Sub

Public Sub SaveAsFile(ByVal FileName As String)
Attribute SaveAsFile.VB_HelpID = 2148
Attribute SaveAsFile.VB_Description = "Saves the wave's sound buffer to another file."
'##BD Saves the wave's sound buffer to another file.

'##PD FileName Name and path of the new wave file.
    On Error GoTo Handler

    Call mvarSoundBuffer.SaveToFile(FileName)
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Wave | SaveAsFile")
End Sub


Public Property Get SoundBuffer() As DirectSoundSecondaryBuffer8
Attribute SoundBuffer.VB_HelpID = 2108
Attribute SoundBuffer.VB_Description = "Returns/sets the DirectSoundBuffer object. Use this object for custom operations.  "
'##BD Returns/sets the DirectSoundBuffer object. Use this object for custom operations.
    Set SoundBuffer = mvarSoundBuffer
End Property

Public Property Set SoundBuffer(ByVal vData As DirectSoundSecondaryBuffer8)
    Set mvarSoundBuffer = vData
End Property

Public Property Get Status() As CONST_DSBSTATUSFLAGS
Attribute Status.VB_HelpID = 2109
Attribute Status.VB_Description = "Returns/ the current status."
'##BD Returns/ the current status.
    Status = mvarSoundBuffer.GetStatus
End Property

Public Property Get Volume() As Long
Attribute Volume.VB_HelpID = 2110
''##BD Returns/sets the volume.
    Volume = mvarSoundBuffer.GetVolume
End Property

Private Sub Class_Terminate()
    Set mvarSoundBuffer3D = Nothing
    Set mvarSoundBuffer = Nothing
End Sub

Public Property Get SoundBuffer3D() As DirectSound3DBuffer8
Attribute SoundBuffer3D.VB_HelpID = 2112
Attribute SoundBuffer3D.VB_Description = "Returns/sets the DirectSound3DBuffer object. Use this object for custom operations.  "
'##BD Returns/sets the DirectSound3DBuffer object. Use this object for custom operations.
    Set SoundBuffer3D = mvarSoundBuffer3D
End Property

Public Property Set SoundBuffer3D(ByVal vData As DirectSound3DBuffer8)
    Set mvarSoundBuffer3D = vData
End Property

Public Sub Play(Optional Looping As Boolean = False)
Attribute Play.VB_HelpID = 2113
Attribute Play.VB_Description = "Plays this wave file."
'##BD Plays this wave file.

'##PD Looping If set to true the wave file will continues until explicitly stopped.
    On Error GoTo Handler

    If Looping = False Then
        Call mvarSoundBuffer.Play(DSBPLAY_DEFAULT)
    Else
        Call mvarSoundBuffer.Play(DSBPLAY_LOOPING)
    End If
    Call SEngine.FireEvents(2, Me)
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Wave | Play")
End Sub

'Public Sub SetFormat(SampleRate As Long, Bits As Integer)
''##BD Sets the format of the primary sound buffer for the application.
'    Dim wf2 As WAVEFORMATEX
'    On Error GoTo Handler
'
'    wf2.lSamplesPerSec = SampleRate
'    wf2.nBitsPerSample = Bits
'
'   Call mvarSoundBuffer.SetFormat(wf2)
'    Exit Sub
'
'Handler:
'    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Wave | SetFormat")
'End Sub

Public Property Get Frequency() As Long
'##BD Returns/sets the frequency, in samples per second, at which the buffer is played.
    Frequency = mvarSoundBuffer.GetFrequency
End Property

Public Property Get format() As WAVEFORMATEX
Attribute format.VB_HelpID = 2150
Attribute format.VB_Description = "Returns a description of the format of the sound data in the buffer."
'##BD Returns a description of the format of the sound data in the buffer.
    Call mvarSoundBuffer.GetFormat(format)
End Property

Public Sub SetConeOrientation(ByVal x As Single, ByVal y As Single, ByVal z As Single)
Attribute SetConeOrientation.VB_HelpID = 2249
Attribute SetConeOrientation.VB_Description = "Sets the orientation of the sound projection cone. This method has no effect unless the cone angle and cone volume factor have also been set."

'##BD Sets the orientation of the sound projection cone. <i>This method has no effect unless the cone angle and cone volume factor have also been set.</i>
    Call mvarSoundBuffer3D.SetConeOrientation(x, y, z, DS3D_IMMEDIATE)
End Sub



Public Property Let Volume(ByVal Volume As Long)
    Call mvarSoundBuffer.SetVolume(Volume)
End Property

Public Sub StopPlaying(Optional ByVal Reset As Boolean = False)
Attribute StopPlaying.VB_HelpID = 2115
Attribute StopPlaying.VB_Description = "Stops the wave from playing."
'##BD Stops the wave from playing.

'##PD Reset If set to True the sound is stopped and the position cursor is set back to 0.
    On Error GoTo Handler

    Call mvarSoundBuffer.Stop
    If Reset = True Then Call mvarSoundBuffer.SetCurrentPosition(0)
    Call SEngine.FireEvents(3, Me)
    Exit Sub

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Wave | StopPlaying")
End Sub

Public Sub SetPosition(ByVal x As Single, ByVal y As Single, ByVal z As Single)
Attribute SetPosition.VB_HelpID = 2250
Attribute SetPosition.VB_Description = "Sets the sound buffer's current position, in distance units."

'##BD Sets the sound buffer's current position, in distance units.
    Call mvarSoundBuffer3D.SetPosition(x, y, z, DS3D_IMMEDIATE)
End Sub

Public Sub SetVelocity(ByVal x As Single, ByVal y As Single, ByVal z As Single)
Attribute SetVelocity.VB_HelpID = 2484
Attribute SetVelocity.VB_Description = "Sets the sound buffer's current velocit, in distance units."

'##BD Sets the sound buffer's current velocit, in distance units.
    Call mvarSoundBuffer3D.SetVelocity(x, y, z, DS3D_IMMEDIATE)
End Sub
Public Sub SetConeAngles(ByVal InCone As Long, ByVal OutCone As Long)
Attribute SetConeAngles.VB_HelpID = 2485
Attribute SetConeAngles.VB_Description = "Sets the inside and outside angles of the sound projection cone."

'##BD Sets the inside and outside angles of the sound projection cone.
    Call mvarSoundBuffer3D.SetConeAngles(InCone, OutCone, DS3D_IMMEDIATE)
End Sub
Public Property Get Pan() As Long
Attribute Pan.VB_HelpID = 2151
Attribute Pan.VB_Description = "Returns/sets the relative volume between the left and right audio channels.  "
'##BD Returns/sets the relative volume between the left and right audio channels.
    Pan = mvarPan
End Property

Public Property Let Pan(ByVal vData As Long)
    mvarPan = vData
    Call mvarSoundBuffer.SetPan(mvarPan)
End Property
