VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Waves8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Wave"
Attribute VB_Ext_KEY = "Member0" ,"Wave"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Collection of Wave8 objects.
Attribute VB_HelpID=2086
Attribute VB_Description="Collection of Wave8 objects."
Option Explicit

'local variable to hold collection
Private mCol As Collection
Public Sub Clear()
Attribute Clear.VB_HelpID = 2089
Attribute Clear.VB_Description = "Removes all the Wave8 objects from the collection."
'##BD Removes all the Wave8 objects from the collection.
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub


Friend Function Add(Key As String, Name_ As String, Path As String, Optional sKey As String) As Wave8
Attribute Add.VB_HelpID = 2090
    'create a new object
    Dim objNewMember As Wave8
    Set objNewMember = New Wave8

    'set the properties passed into the method
    With objNewMember
        .Key = Key
        .Name_ = Name_
        .Path = Path
    End With

    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Function LoadWaveFromFile(ByVal FileName As String, ByVal Name As String, _
                                                                    Optional ByVal Use3DBuffer As Boolean = False, _
                                                                    Optional GUID3DAlgorithm As String = "GUID_DS3DALG_NO_VIRTUALIZATION") As Wave8
Attribute LoadWaveFromFile.VB_HelpID = 2514
Attribute LoadWaveFromFile.VB_Description = "Creates a new Wave8 object in the collection by loading a Wave8 file."
'##BD Creates a new Wave8 object in the collection by loading a Wave8 file.

'##PD FileName Location of the Wave8 file to load.
'##PD Name Name of the Wave8 file within the collection. <i>Name is used purely for your reference.</i>
'##PD Use3DBuffer If True a 3D sound buffer is also created.
    Dim NumBuffer As Integer
    Dim D3 As Long, i As Long
    On Error GoTo Handler

    'Set 3D buffer flags
    If Use3DBuffer = True Then D3 = DSBCAPS_CTRL3D Else D3 = 0

    NumBuffer = Count + 1
    
    'Setup the DESC type
    Desc.lFlags = D3 Or DSBCAPS_CTRLVOLUME
    If D3 <> 0 Then Desc.GUID3DAlgorithm = GUID3DAlgorithm
    
    'Test for PAK file and add to the collection.
'    Call TestPakFile(FileName)
    Set LoadWaveFromFile = Add(CStr(NumBuffer), Name, FileName, Name)
    Set LoadWaveFromFile.SoundBuffer = SEngine.DirectSoundObject.CreateSoundBufferFromFile(FileName, Desc)
'    Call DeleteTempPAK

    'If the user wants a 3D buffer we set the SoundBuffer3D property to the 3D version of the regular sound buffer.
    If D3 <> 0 Then
        Set LoadWaveFromFile.SoundBuffer3D = LoadWaveFromFile.SoundBuffer.GetDirectSound3DBuffer
    End If

    Call SEngine.FireEvents(1, LoadWaveFromFile)
    Exit Function

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Waves | LoadWaveFromFile")
End Function

Public Function LoadWaveFromResource(ByVal dll As String, ByVal ResourceName As String, _
                                                                            Optional ByVal Use3DBuffer As Boolean = False, _
                                                                            Optional GUID3DAlgorithm As String = "GUID_DS3DALG_NO_VIRTUALIZATION") As Wave8
Attribute LoadWaveFromResource.VB_HelpID = 2515
Attribute LoadWaveFromResource.VB_Description = "Creates a new Wave8 object in the collection by loading a Wave8 file from a dll."
'##BD Creates a new Wave8 object in the collection by loading a Wave8 file from a dll.

'##PD dll Location of the dynamic linking library to load.
'##PD ResourceName Name of the resource.
'##PD Use3DBuffer If True a 3D sound buffer is also created.
    Dim NumBuffer As Integer
    Dim D3 As Long, i As Long
    On Error GoTo Handler

    'Set 3D buffer flags
    If Use3DBuffer = True Then D3 = DSBCAPS_CTRL3D Else D3 = 0

    NumBuffer = Count + 1
    
    'Setup the DESC type
    Desc.lFlags = D3 Or DSBCAPS_CTRLVOLUME
    If D3 <> 0 Then Desc.GUID3DAlgorithm = GUID3DAlgorithm

    'Test for PAK file and add to the collection.
    Set LoadWaveFromResource = Add(CStr(NumBuffer), ResourceName, dll, CStr(NumBuffer))
    Set LoadWaveFromResource.SoundBuffer = SEngine.DirectSoundObject.CreateSoundBufferFromResource(dll, ResourceName, Desc)

    'If the user wants a 3D buffer we set the SoundBuffer3D property to the 3D version of the regular sound buffer.
    If D3 <> 0 Then
        Set LoadWaveFromResource.SoundBuffer3D = LoadWaveFromResource.SoundBuffer.GetDirectSound3DBuffer
    End If

    Call SEngine.FireEvents(1, LoadWaveFromResource)
    Exit Function

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Waves | LoadWaveFromResource")
End Function

Public Function Duplicate(Wave8 As Wave8, ByVal Name As String, Optional ByVal Use3DBuffer As Boolean = False) As Wave8
Attribute Duplicate.VB_HelpID = 2093
Attribute Duplicate.VB_Description = "Creates a new Wave8 object in the collection by copying the contents of another Wave8 file."
'##BD Creates a new Wave8 object in the collection by copying the contents of another Wave8 file.

'##PD Wave8 Wave8 object to copy from.
'##PD Name Name of the Wave8 file within the collection. <i>Name is used purely for your reference.</i>
'##PD Use3DBuffer If True a 3D sound buffer is also created.
    Dim NumBuffer As Integer
    Dim D3 As Long, i As Long
    On Error GoTo Handler

    'Set 3D buffer flags
    If Use3DBuffer = True Then D3 = DSBCAPS_CTRL3D Else D3 = 0

    NumBuffer = Count + 1
    Desc.lFlags = (D3 Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC

    'Add to the waves collection then set the duplicate the buffer.
    Set Duplicate = Add(CStr(NumBuffer), Name, Wave8.Path, CStr(NumBuffer))
    Set Duplicate.SoundBuffer = SEngine.DirectSoundObject.DuplicateSoundBuffer(Wave8.SoundBuffer) 'Duplicate the sound buffer.

    'If the user wants a 3D buffer we just set the new Wave8's 3D buffer to the passed in Wave8 3D buffer
    If D3 <> 0 Then
        Set Duplicate.SoundBuffer3D = Wave8.SoundBuffer3D
    End If

    Call SEngine.FireEvents(1, Duplicate)
    Exit Function

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Waves | Duplicate")
End Function

Public Function CreateWave(ByVal Name As String, Optional BufferBytes As Long = 0, _
                                                    Optional ByVal BufferFlags As CONST_DSBCAPSFLAGS = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME, _
                                                    Optional ByVal Use3DBuffer As Boolean = False, _
                                                    Optional GUID3DAlgorithm As String = "GUID_DS3DALG_NO_VIRTUALIZATION") As Wave8
Attribute CreateWave.VB_HelpID = 2516
Attribute CreateWave.VB_Description = "Creates a new Wave8 object in the collection."
'##BD Creates a new Wave8 object in the collection.

'##PD Name Name of the Wave8 file within the collection. <i>Name is used purely for your reference.</i>
'##PD Format
'##PD BufferBytes
'##PD BufferFlags
'##PD Use3DBuffer If True a 3D sound buffer is also created.
    Dim BufferDesc As DSBUFFERDESC
    Dim NumBuffer As Integer
    Dim D3 As Long, i As Long
    On Error GoTo Handler

    'Set 3D buffer flags
    If Use3DBuffer = True Then D3 = DSBCAPS_CTRL3D Else D3 = 0
    
    NumBuffer = Count + 1
    
    'Setup the buffer description
    BufferDesc.lBufferBytes = BufferBytes
    BufferDesc.lFlags = D3 Or BufferFlags
    If D3 <> 0 Then Desc.GUID3DAlgorithm = GUID3DAlgorithm

    'Add to the waves collection then set the duplicate the buffer.
    Set CreateWave = Add(CStr(NumBuffer), Name, "N/A", CStr(NumBuffer))
    Set CreateWave.SoundBuffer = SEngine.DirectSoundObject.CreateSoundBuffer(BufferDesc)

    'If the user wants a 3D buffer we just set the new Wave8's 3D buffer to the passed in Wave8 3D buffer
    If D3 <> 0 Then
        Set CreateWave.SoundBuffer3D = CreateWave.SoundBuffer.GetDirectSound3DBuffer
    End If

    Call SEngine.FireEvents(1, CreateWave)
    Exit Function

Handler:
    Call SEngine.FireErrorEvent(Err.Number, Err.Description, "Waves | CreateWave")
End Function
Public Property Get Item(vntIndexKey As Variant) As Wave8
Attribute Item.VB_HelpID = 2095
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
'##Returns a Wave8 object.
    Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2096
Attribute Count.VB_Description = "Returns the total number of Wave8 objects in the collection."
'##BD Returns the total number of Wave8 objects in the collection.
    Count = mCol.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_HelpID = 2097
Attribute Remove.VB_Description = "Removes a Wave8 object from the collection."
'##BD Removes a Wave8 object from the collection.
    Set Item(vntIndexKey).SoundBuffer = Nothing
    Set Item(vntIndexKey).SoundBuffer3D = Nothing

    Call mCol.Remove(vntIndexKey)
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2098
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

