Attribute VB_Name = "basMain"
Attribute VB_HelpID=2002
Option Explicit

Public DirectX As DirectX8
Public SEngine As SoundEngine8

'-----------------------------------
' DirectSound Declarations
'-----------------------------------
Public DSListener3D As DirectSound3DListener8
Public DSPrimary As DirectSoundPrimaryBuffer8

Public Desc As DSBUFFERDESC
Public WF As WAVEFORMATEX

'Public Buffer(1 To NDSB) As Boolean
'Public FileOp As FileOperation
Public PakFileLoaded As String

'Multimedia stuff
Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Public Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" (ByVal dwError As Long, ByVal lpstrBuffer As String, ByVal uLength As Long) As Long
Public Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long

Attribute DirectX.VB_VarHelpID = 2005
Attribute SEngine.VB_VarHelpID = 2006
Attribute DSListener3D.VB_VarHelpID = 2009
Attribute Desc.VB_VarHelpID = 2011
Attribute WF.VB_VarHelpID = 2012
Attribute PakFileLoaded.VB_VarHelpID = 2255
Public Function GetRandomNumber(Upper As Integer, Lower As Integer) As Long
Attribute GetRandomNumber.VB_HelpID = 2285
'===================================================================================
'Purpose: Gets a random number.
'Inputs: Upper - highest the number can be / Lower - lowest the number can be.
'Outputs: Long containing the random number.
'Notes: Using a number for the Upper perameter too high will cause an error. VB for some reason can't process it correctly.
'Date/Time Created: 11/10/98 11:28:27 AM
'===================================================================================
    Randomize
    GetRandomNumber = CLng(Int((Upper - Lower + 1) * Rnd + Lower))
End Function

Public Function GetFramesPerSecond(AliasName As String) As Long
Attribute GetFramesPerSecond.VB_HelpID = 2286
    Dim TotalFrames As Long
    Dim TotalTime As Long

    TotalTime = GetTotalTimeByMS(AliasName)
    TotalFrames = GetTotalframes(AliasName)
    If TotalFrames = -1 Or TotalTime = -1 Then 'Not success
        GetFramesPerSecond = -1
        Exit Function
    End If

    'Success
    GetFramesPerSecond = TotalFrames / (TotalTime / 1000)
End Function

Public Function GetTotalTimeByMS(AliasName As String) As Long
Attribute GetTotalTimeByMS.VB_HelpID = 2287
    Dim dwReturn As Long
    Dim TotalTime As String * 128

    dwReturn = mciSendString("set " & AliasName & " time format ms", TotalTime, 128, 0&)
    dwReturn = mciSendString("status " & AliasName & " length", TotalTime, 128, 0&)

    Call mciSendString("set " & AliasName & " time format frames", 0&, 128, 0&)  ' return focus to frames not to time

    If Not dwReturn = 0 Then  'not success
        GetTotalTimeByMS = -1
        Exit Function
    End If

    'Success
    GetTotalTimeByMS = Val(TotalTime)
End Function

Public Function GetTotalframes(AliasName As String) As Long
Attribute GetTotalframes.VB_HelpID = 2288
    Dim dwReturn As Long
    Dim Total As String * 128

    dwReturn = mciSendString("set " & AliasName & " time format frames", Total, 128, 0&)
    dwReturn = mciSendString("status " & AliasName & " length", Total, 128, 0&)

    If Not dwReturn = 0 Then  'not success
        GetTotalframes = -1
        Exit Function
    End If

    'Success
    GetTotalframes = Val(Total)
End Function
'Public Sub TestPakFile(ByRef FileName As String)
'    If FileOp Is Nothing Then Exit Sub
'    PakFileLoaded = FileOp.LoadFromPAKFile(CurDir$, FileName)
'End Sub

' Add info to log file
Public Sub AddLog(log As String)
Attribute AddLog.VB_HelpID = 2257
    Open "c:\debug.dat" For Append As 44
    Print #44, Date; " "; Time; " " + log
    Close #44
'    If DisplayConsole = True Then
'        LocalConsole.WriteConsole log, RGB(0, 256, 256)
'        FlipToScreen
'    End If
End Sub
'Public Sub DeleteTempPAK()
'    If FileOp Is Nothing Then Exit Sub
'    FileOp.DeleteTemporaryFile CurDir$, PakFileLoaded
'End Sub
